﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public X, Modifier As Float
	Public ParentID,  SpouseID As String
	Public Y As Int
	Public Children As List
	Public Parent As Tree
	Public Spouse As Tree
	Public Width As Float
	Public Height As Int
	Public Name, ID As String
	Public IsRoot As Boolean = False
	Dim X1, X2, Y1, Y2, SpouseX1, SpouseX2,SpouseY1, SpouseY2 As Float
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ID1 As String)
	'initilaize the current node and it's parent id and also ids of it's childern
	ID = ID1
	Children.Initialize
	X1 = 0
	X2 = 0
	Y1 = 0
	Y2 = 0
	SpouseX1 = 0
	SpouseX2 = 0
	SpouseY1 = 0
	SpouseY2 = 0	
	'ParentID = Parent1
	'Children = childList

End Sub
Public Sub AddParent(node As Tree)
	Parent = node
End Sub
Public Sub AddChildren(nodeList As List)
	Children = nodeList
End Sub

Public Sub IsLeaf() As Boolean
	If Children.Size = 0 Then
		Return True
	Else
		Return False
	End If
End Sub				
Public Sub IsLeftMost() As Boolean
	'Log ("Current id" & ID)
	
	Dim temp As Tree
	'temp = Parent.Children.Get(0)
	'Log ("Class child id" & temp.ID)
	If Parent = Null Then
		Return True
	Else If Parent.ID  = "" Then
			Return True
	Else 
		If Parent.Children.Size > 0 Then
			If Parent.Children.Get(0) = Me Then
				Return True
			Else
				Return False
			End If
		Else
			Return False
		End If	
	End If
	
End Sub
Public Sub IsRightMost () As Boolean
	If Parent = Null Then
		Return True
	Else If Parent.ID = "" Then
		Return True
	Else
		If Parent.Children.Size > 0 Then
			If Parent.Children.Get(Parent.Children.Size - 1) = Me Then
				Return True
			Else
				Return False
			End If
		Else
			Return False
		End If	
	End If
End Sub
Public Sub GetPreviousSibling() As Tree
If Parent = Null Then
	Return Null
Else If Parent.ID  = "" OR IsLeftMost Then
	Return Null
Else		
	Return Parent.Children.Get(Parent.Children.IndexOf(Me) - 1)
End If
	
End Sub
Public Sub GetNextSibling() As Tree
If Parent = Null Then
	Return Null
Else If Parent.ID  = "" OR IsRightMost Then
	Return Null
Else		
	Return Parent.Children.Get(Parent.Children.IndexOf(Me) + 1)
End If	
End Sub
Public Sub GetLeftMostSibling() As Tree
	If Parent = Null Then
		Return Null
	Else If Parent.ID  = "" Then
		Return Null
	Else If IsLeftMost Then
		Return Me		
	Else
		Return Parent.Children.Get(0)
	End If
End Sub
Public Sub GetLeftMostChild() As Tree
	If Children.Size = 0 Then
		Return Null			
	Else
		Return Children.Get(0)
	End If
End Sub
Public Sub GetRightMostChild() As Tree
	If Children.Size = 0 Then
		Return Null			
	Else
		Return Children.Get(Children.Size - 1)
	End If
End Sub
Public Sub HasSpouse() As Boolean
	If SpouseID = "" Then Return False Else Return True	
End Sub